/*
 * Created on 18-ene-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package user.ejb;

import java.rmi.RemoteException;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import javax.ejb.*;
import user.interfaces.*;
import user.exception.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @ejb.bean name="UserFacade"
 *           display-name="Name for UserFacade"
 *           description="Description for UserFacade"
 *           jndi-name="ejb/UserFacade"
 *           type="Stateless"
 *           view-type="both"
 * 
 * @ejb.util generate="physical"
 */
public class UserFacadeBean implements SessionBean {
	
	UserLocalHome userHome = null;

	/**
	 * 
	 */
	public UserFacadeBean() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbRemove()
	 */
	public void ejbRemove() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
	 */
	public void setSessionContext(SessionContext ctx)
		throws EJBException,
		RemoteException {
		// TODO Auto-generated method stub

	}

	/**
	 * Default create method
	 * 
	 * @throws CreateException
	 * @ejb.create-method
	 */
	public void ejbCreate() throws CreateException {
		// TODO Auto-generated method stub
		try {
			userHome = UserUtil.getLocalHome();
		} catch (Exception e) {
			throw new CreateException(e.getMessage());
		}
	}

	private boolean validarNIF(String NIF) {
		String calculNif = "TRWAGMYFPDXBNJZSQVHLCKE";
		boolean valid;
		int iNIF;
		int lletra;
		
		try {
			iNIF = Integer.parseInt(NIF.substring(0, 8));
			lletra = NIF.charAt(NIF.length() - 1);
			if (calculNif.charAt(iNIF % 23) == lletra) {
				valid = true;
			} else {
				valid = false;
			}
		} catch (Exception ex) {
			valid = false;
		}
		
		return valid;
	}
	
	public boolean validarEmail(String email) {
		// Expressio regular extreta de http://regexlib.com/
		Pattern p = Pattern.compile("^([0-9a-zA-Z]([-.\\w]*[0-9a-zA-Z])*@([0-9a-zA-Z][-\\w]*[0-9a-zA-Z]\\.)+[a-zA-Z]{2,9})$");
		Matcher m = p.matcher(email);
		if (m.find()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void alta(user.interfaces.UserValue value) throws CreateException, NIFIncorrecteException, EmailIncorrecteException {
		// TODO Auto-generated method stub
		if (! this.validarNIF(value.getNIF())) {
			throw new NIFIncorrecteException();
		}
		if (! this.validarEmail(value.getEmail())) {
			throw new EmailIncorrecteException();
		}
		userHome.create(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void baixa(String login) throws FinderException, RemoveException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		user.remove();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public user.interfaces.UserValue getValors(String login) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		return user.getValors();
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public void setValors(String login, user.interfaces.UserValue value) throws FinderException,NIFIncorrecteException, EmailIncorrecteException {
		// TODO Auto-generated method stub
		if (! this.validarNIF(value.getNIF())) {
			throw new NIFIncorrecteException();
		}
		if (! this.validarEmail(value.getEmail())) {
			throw new EmailIncorrecteException();
		}
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		user.setValors(value);
	}
	/**
	 * Business method
	 * @ejb.interface-method  view-type = "both"
	 */
	public java.lang.Boolean validarPassword(String login, String password) throws FinderException {
		// TODO Auto-generated method stub
		UserLocal user = userHome.findByPrimaryKey(new UserPK(login));
		String currentPass = user.getPassword();
		if (currentPass.compareTo(password) == 0) {
			return new Boolean(true);
		} else {
			return new Boolean(false);
		}
	}
}