/*
 * Created on 19-ene-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package user.junit;

import junit.framework.TestCase;

import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;
import javax.naming.Context;
import javax.naming.InitialContext;
import user.interfaces.*;
import user.exception.*;

/**
 * EJB Test Client
 */
public class Test1 extends TestCase {

	/** Home interface */
	protected user.interfaces.UserFacadeHome home;
	/**
	 * Get the initial naming context
	 */
	protected Context getInitialContext() throws Exception {
		Hashtable props = new Hashtable();
		props.put(
			Context.INITIAL_CONTEXT_FACTORY,
			"org.jnp.interfaces.NamingContextFactory");
		props.put(
			Context.URL_PKG_PREFIXES,
			"org.jboss.naming:org.jnp.interfaces");
		props.put(Context.PROVIDER_URL, "jnp://localhost:1099");
		Context ctx = new InitialContext(props);
		return ctx;
	}

	/**
	 * Get the home interface
	 */
	protected user.interfaces.UserFacadeHome getHome() throws Exception {
		Context ctx = this.getInitialContext();
		Object o = ctx.lookup("ejb/UserFacade");
		user.interfaces.UserFacadeHome intf = (user.interfaces.UserFacadeHome) PortableRemoteObject
			.narrow(o, user.interfaces.UserFacadeHome.class);
		return intf;
	}

	/**
	 * Set up the test case
	 */
	protected void setUp() throws Exception {
		this.home = this.getHome();
	}

	/**
	 * Test for user.interfaces.UserFacade.alta(user.interfaces.UserValue value)
	 */
	public void testAlta() throws Exception {
		user.interfaces.UserFacade instance;

		// Parameters
		user.interfaces.UserValue param0 = new UserValue();
		param0.setAdress("Pere Martell");
		param0.setCognom("Blanco");
		param0.setEmail("mi@mail.com");
		param0.setLogin("marble0");
		param0.setNIF("47761355S");
		param0.setNom("Sergio");
		param0.setPassword("secret");
		param0.setTelefon("977030201");

		// Instance creation
		instance = this.home.create();
		
		// Ens asegurem que no existeix
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
		}

		// Method call
		boolean NIFIncorrecte = false;
		boolean EmailIncorrecte = false;
		boolean creat = false;
		
		try {
			instance.alta(param0);
			creat = true;
		} catch (NIFIncorrecteException e) {
			NIFIncorrecte = true;
		} catch (EmailIncorrecteException e) {
			EmailIncorrecte = true;
		} catch (Exception e) {
			creat = false;
		}
		
		// Various assertions
		instance.baixa(param0.getLogin());
		
		assertEquals(creat,true);
		assertEquals(NIFIncorrecte,false);
		assertEquals(EmailIncorrecte,false);
		
		
	}

	/**
	 * Test for user.interfaces.UserFacade.baixa(java.lang.String login)
	 */
	public void testBaixa() throws Exception {
		user.interfaces.UserFacade instance;

		// Parameters
		user.interfaces.UserValue param0 = new UserValue();
		param0.setAdress("Pere Martell");
		param0.setCognom("Blanco");
		param0.setEmail("mi@mail.com");
		param0.setLogin("marble1");
		param0.setNIF("47761355S");
		param0.setNom("Sergio");
		param0.setPassword("secret");
		param0.setTelefon("977030201");

		// Instance creation
		instance = this.home.create();
		
		// Ens asegurem que no existeix
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
		}

		// Method call
		boolean error = false;
		instance.alta(param0);
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
			error = true;
		}

		// Various assertions
		assertEquals(error,false);
	}

	/**
	 * Test for user.interfaces.UserFacade.getValors(java.lang.String login)
	 */
	public void testGetValors() throws Exception {
		user.interfaces.UserFacade instance;
		user.interfaces.UserValue result;

		// Parameters
		user.interfaces.UserValue param0 = new UserValue();
		param0.setAdress("Pere Martell");
		param0.setCognom("Blanco");
		param0.setEmail("mi@mail.com");
		param0.setLogin("marble2");
		param0.setNIF("47761355S");
		param0.setNom("Sergio");
		param0.setPassword("secret");
		param0.setTelefon("977030201");

		// Instance creation
		instance = this.home.create();
		
		// Ens asegurem que no existeix
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
		}

		// Method call
		boolean error = false;
		instance.alta(param0);
		try {
			result = instance.getValors(param0.getLogin());
			if (result.getLogin().compareTo(param0.getLogin()) != 0) {
				error = true;
			}
		} catch (Exception e) {
			error = true;
		}
		instance.baixa(param0.getLogin());
			

		// Various assertions
		// assertNotNull(result);
		assertEquals(error,false);
	}

	/**
	 * Test for user.interfaces.UserFacade.setValors(java.lang.String login, user.interfaces.UserValue value)
	 */
	public void testSetValors() throws Exception {
		user.interfaces.UserFacade instance;

		// Parameters
		user.interfaces.UserValue param0 = new UserValue();
		param0.setAdress("Pere Martell");
		param0.setCognom("Blanco");
		param0.setEmail("mi@mail.com");
		param0.setLogin("marble3");
		param0.setNIF("47761355S");
		param0.setNom("Sergio");
		param0.setPassword("secret");
		param0.setTelefon("977030201");
		
		user.interfaces.UserValue param1 = new UserValue();
		param1.setAdress("Pere Martell2");
		param1.setCognom("Blanco2");
		param1.setEmail("mi2@mail.com");
		param1.setLogin("marble3");
		param1.setNIF("47761355S");
		param1.setNom("Sergio2");
		param1.setPassword("secret2");
		param1.setTelefon("9770302012");

		// Instance creation
		instance = this.home.create();

		// Ens asegurem que no existeix
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
		}
		
		// Method call
		boolean error = false;
		boolean addressOK = false;
		boolean cognomOK = false;
		boolean emailOK = false;
		boolean loginOK = false;
		boolean NIFOK = false;
		boolean nomOK = false;
		boolean passwordOK = false;
		boolean telefonOK = false;
		boolean NIFIncorrecte = false;
		boolean EmailIncorrecte = false;
		instance.alta(param0);
		
		try {
			instance.setValors(param0.getLogin(), param1);
		} catch (NIFIncorrecteException e) {
			NIFIncorrecte = true;
		} catch (EmailIncorrecteException e) {
			EmailIncorrecte = true;
		} catch (Exception e) {
			error = true;
		}
		
		UserValue result = instance.getValors(param0.getLogin());
		if (result.getAdress().compareTo(param1.getAdress()) == 0) {
			addressOK = true;
		}
		if (result.getCognom().compareTo(param1.getCognom()) == 0) {
			cognomOK = true;
		}
		if (result.getLogin().compareTo(param0.getLogin()) == 0) {
			loginOK = true;
		}
		if (result.getNIF().compareTo(param1.getNIF()) == 0) {
			NIFOK = true;
		}
		if (result.getNom().compareTo(param1.getNom()) == 0) {
			nomOK = true;
		}
		if (result.getPassword().compareTo(param1.getPassword()) == 0) {
			passwordOK = true;
		}
		if (result.getTelefon().compareTo(param1.getTelefon()) == 0) {
			telefonOK = true;
		}
		if (result.getEmail().compareTo(param1.getEmail()) == 0) {
			emailOK = true;
		}
		
		instance.baixa(param0.getLogin());
		
		// Various assertions
		assertEquals(error,false);
		assertEquals(NIFIncorrecte,false);
		assertEquals(EmailIncorrecte,false);
		assertEquals(addressOK,true);
		assertEquals(cognomOK,true);
		assertEquals(emailOK,true);
		assertEquals(loginOK,true);
		assertEquals(NIFOK,true);
		assertEquals(nomOK,true);
		assertEquals(passwordOK,true);
		assertEquals(telefonOK,true);
		
	}

	/**
	 * Test for user.interfaces.UserFacade.validarPassword(java.lang.String login, java.lang.String password)
	 */
	public void testValidarPassword() throws Exception {
		user.interfaces.UserFacade instance;
		java.lang.Boolean result = new Boolean(false);

		// Parameters
		user.interfaces.UserValue param0 = new UserValue();
		param0.setAdress("Pere Martell");
		param0.setCognom("Blanco");
		param0.setEmail("mi@mail.com");
		param0.setLogin("marble5");
		param0.setNIF("47761355S");
		param0.setNom("Sergio");
		param0.setPassword("secret");
		param0.setTelefon("977030201");

		// Instance creation
		instance = this.home.create();

		// Ens asegurem que no existeix
		try {
			instance.baixa(param0.getLogin());
		} catch (Exception e) {
		}
		
		// Method call
		boolean error = false;
		instance.alta(param0);
		try {
			result = instance.validarPassword(param0.getLogin(), param0.getPassword());
		} catch (Exception e) {
			error = true;
		}
		
		// Various assertions
		// assertNotNull(result);
		assertEquals(error,false);
		assertEquals(result.booleanValue(),true);
	}
}